package com.sys.bus.excel.tool;


import org.apache.poi.hssf.util.HSSFColor;
import org.apache.poi.ss.usermodel.*;
import org.apache.poi.xssf.usermodel.XSSFCellStyle;
import org.apache.poi.xssf.usermodel.XSSFRichTextString;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.io.IOException;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * @author
 */
public class ExportExcel {

    /**
     * 显示的导出表的标题
     */
    private String title;

    /**
     * 导出表的列名
     */
    private String[] columnName;

    /**
     * 导出表的列格式  1字符串 2数字
     */
    private int[] columnType;
    /**
     * 需要导出的数据集合
     */
    private List<Object[]> dataList = new ArrayList<Object[]>();

    private OutputStream os;



    /**
     * 构造方法，传入要导出的数据
     */
    public ExportExcel(String title, String[] columnName,int[] columnType, List<Object[]> dataList,OutputStream os) {
        this.dataList = dataList;
        this.columnName = columnName;
        this.title = title;
        this.columnType =columnType;
        this.os = os;
    }


    /**
     *  导出数据到excel
     */
    public void export() throws Exception {

        try {
            Workbook workbook = new XSSFWorkbook();                        // 创建工作簿对象
            Sheet sheet = workbook.createSheet(title);                     // 创建工作表

            // 产生表格标题行
            Row rowm = sheet.createRow(0);
            Cell cellTiltle = rowm.createCell(0);

            //设置标题和单元格样式
            CellStyle columnTopStyle = this.getColumnTopStyle(workbook);  //获取列头样式对象
            XSSFCellStyle style = this.getStyle(workbook);                    //单元格样式对象
            XSSFCellStyle style1 = this.getStyle(workbook);
            style1.setDataFormat((short) 10);
            int rowStart = 0; //从第几行开始写表头
//            //合并单元格
//            sheet.addMergedRegion(new CellRangeAddress(0, 1, 0, (columnName.length - 1)));
//            cellTiltle.setCellStyle(columnTopStyle);
//            cellTiltle.setCellValue(title);

            // 定义所需列数
            int columnNum = columnName.length;
            Row rowRowName = sheet.createRow(rowStart);                 // 在索引2的位置创建行(最顶端的行开始的第二行)


            // 将列头设置到sheet的单元格中
            for (int n = 0; n < columnNum; n++) {
                Cell cellRowName = rowRowName.createCell(n);                  //创建列头对应个数的单元格
                cellRowName.setCellType(Cell.CELL_TYPE_STRING);                //设置列头单元格的数据类型
                RichTextString text = new XSSFRichTextString(columnName[n]);
                cellRowName.setCellValue(text);                                    //设置列头单元格的值
                cellRowName.setCellStyle(columnTopStyle);                          //设置列头单元格样式
            }

            //将查询出的数据设置到sheet对应的单元格中
            for (int i = 0; i < dataList.size(); i++) {
                Object[] obj = dataList.get(i);//遍历每个对象
                Row row = sheet.createRow(i + (rowStart+1));//创建所需的行数
                for (int j = 0; j < obj.length; j++) {
                    Cell cell = null;   //设置单元格的数据类型
                    int type =columnType[j];
                    style.setDataFormat((short) 0);
                    if (type == 2||type == 3) {
                        cell = row.createCell(j, Cell.CELL_TYPE_NUMERIC);
                        Object o = obj[j];
                        if(o!=null && o.toString().length()>0){
                            if(o instanceof BigDecimal){
                                cell.setCellValue(((BigDecimal)o).doubleValue());
                            }else if(o instanceof Integer){
                                cell.setCellValue(((Integer)o).doubleValue());
                            }else if(o instanceof Double){
                                cell.setCellValue((Double)o);
                            }else if(o instanceof Float){
                                cell.setCellValue((Float)o);
                            }else{
                                cell.setCellValue(Double.valueOf(obj[j].toString()));
                            }
                        }

                    } else{
                        cell = row.createCell(j, Cell.CELL_TYPE_STRING);
                        if (!"".equals(obj[j]) && obj[j] != null) {
                            cell.setCellValue(obj[j].toString());
                        }
                    }

                    if(type == 3){
                        cell.setCellStyle(style1);                                    //设置单元格样式
                    }else{
                        cell.setCellStyle(style);
                    }

                }
            }


            //让列宽随着导出的列长自动适应
            for (int colNum = 0; colNum < columnNum; colNum++) {
                int columnWidth = sheet.getColumnWidth(colNum) / 256;
                for (int rowNum = 0; rowNum < sheet.getLastRowNum(); rowNum++) {
                    Row currentRow;
                    //当前行未被使用过
                    if (sheet.getRow(rowNum) == null) {
                        currentRow = sheet.createRow(rowNum);
                    } else {
                        currentRow = sheet.getRow(rowNum);
                    }
                    if (currentRow.getCell(colNum) != null) {
                        //取得当前的单元格
                        Cell currentCell = currentRow.getCell(colNum);
                        //如果当前单元格类型为字符串
                        if (currentCell.getCellType() == Cell.CELL_TYPE_STRING) {
                        int length = currentCell.getStringCellValue().getBytes().length;
                        if(length > 100) length = 100;
                            if (columnWidth < length) {
                                //将单元格里面值大小作为列宽度
                                columnWidth = length;
                            }
                        }
                    }
                }
                //再根据不同列单独做下处理
                if (colNum == 0) {
                    sheet.setColumnWidth(colNum, (columnWidth - 2) * 256);
                } else {
                    sheet.setColumnWidth(colNum, (columnWidth + 4) * 256);
                }
            }

            if (workbook != null) {
                try {
                    workbook.write(os);
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    /**
     *  标题行的单元格样式
     */
    public XSSFCellStyle getColumnTopStyle(Workbook workbook) {

        // 设置字体
        Font font = workbook.createFont();
        //设置字体大小
        font.setFontHeightInPoints((short) 11);
        //字体加粗
        font.setBoldweight(Font.BOLDWEIGHT_BOLD);
        //设置字体名字
        font.setFontName("Courier New");
        //设置样式;
        XSSFCellStyle style = (XSSFCellStyle)workbook.createCellStyle();
        style.setFillForegroundColor(IndexedColors.BLUE.getIndex());
        //设置底边框;
        style.setBorderBottom(CellStyle.BORDER_THIN);
        //设置底边框颜色;
        style.setBottomBorderColor(HSSFColor.BLACK.index);
        //设置左边框;
        style.setBorderLeft(CellStyle.BORDER_THIN);
        //设置左边框颜色;
        style.setLeftBorderColor(HSSFColor.BLACK.index);
        //设置右边框;
        style.setBorderRight(CellStyle.BORDER_THIN);
        //设置右边框颜色;
        style.setRightBorderColor(HSSFColor.BLACK.index);
        //设置顶边框;
        style.setBorderTop(CellStyle.BORDER_THIN);
        //设置顶边框颜色;
        style.setTopBorderColor(HSSFColor.BLACK.index);
        //在样式用应用设置的字体;
        style.setFont(font);
        //设置自动换行;
        style.setWrapText(false);
        //设置水平对齐的样式为居中对齐;
        style.setAlignment(CellStyle.ALIGN_CENTER);
        //设置垂直对齐的样式为居中对齐;
        style.setVerticalAlignment(CellStyle.VERTICAL_CENTER);
        return style;
    }

    /**
     *  列数据信息单元格样式
     */
    public XSSFCellStyle getStyle(Workbook workbook) {
        // 设置字体
        Font font = workbook.createFont();
        //设置字体大小
        //font.setFontHeightInPoints((short)10);
        //字体加粗
        //font.setBoldweight(Font.BOLDWEIGHT_BOLD);
        //设置字体名字
        font.setFontName("Courier New");
        //设置样式;
        XSSFCellStyle style = (XSSFCellStyle)workbook.createCellStyle();
        //设置底边框;
        style.setBorderBottom(CellStyle.BORDER_THIN);
        //设置底边框颜色;
        style.setBottomBorderColor(HSSFColor.BLACK.index);
        //设置左边框;
        style.setBorderLeft(CellStyle.BORDER_THIN);
        //设置左边框颜色;
        style.setLeftBorderColor(HSSFColor.BLACK.index);
        //设置右边框;
        style.setBorderRight(CellStyle.BORDER_THIN);
        //设置右边框颜色;
        style.setRightBorderColor(HSSFColor.BLACK.index);
        //设置顶边框;
        style.setBorderTop(CellStyle.BORDER_THIN);
        //设置顶边框颜色;
        style.setTopBorderColor(HSSFColor.BLACK.index);
        //在样式用应用设置的字体;
        style.setFont(font);
        //设置自动换行;
        style.setWrapText(false);
        //设置水平对齐的样式为居中对齐;
        style.setAlignment(CellStyle.ALIGN_CENTER);
        //设置垂直对齐的样式为居中对齐;
        style.setVerticalAlignment(CellStyle.VERTICAL_CENTER);
        return style;
    }
}